<template>
  <div class="wrapper" :class="themeClasses">
    <preorder-filter
      ref="preorderFilter"
      :strategies="strategies"
      :category="category"
      @changed="updateStrategy"
    />
    <div class="alarm">
      <alarm class="lg-up-show" :fixed="true">
        <span slot="tag">{{ $t("preorderTutorial.takeoutSteps") }}</span>
        <div slot="content">
          <div class="tutorial-button-container flex-inline">
            <template v-for="button in buttons">
              <preorder-tutorial-button
                @onAnchorClick="openPreorderTutorialPage"
                :icon="button.icon"
                layout="inline"
                :key="button.name"
              >
                <img
                  slot="icon"
                  class="icon"
                  :src="
                    '/static/images/preorder-tutorial/icon-' +
                      button.icon +
                      '-s.svg'
                  "
                />
                <template slot="text">{{
                  $t("preorderTutorial.button." + button.name)
                }}</template>
              </preorder-tutorial-button>
              <div :key="button.icon" class="ic-proc-next"></div>
            </template>
          </div>
        </div>
      </alarm>

      <alarm>
        <span slot="tag">{{ $t("preorderGroup.warningTag") }}</span>
        <div slot="content" v-html="$t('preorderGroup.warningContent')"></div>
      </alarm>
    </div>

    <div :class="{ container: !isMobile }">
      <div
        v-if="loading"
        class="restaurant-list"
        :class="{ desktop: !isMobile }"
      >
        <div class="restaurant-item"><restaurant /></div>
        <div class="restaurant-item"><restaurant /></div>
        <div class="restaurant-item"><restaurant /></div>
      </div>

      <div
        v-if="!loading"
        class="restaurant-list"
        :class="{ desktop: !isMobile }"
      >
        <div class="restaurant-item" v-for="restaurant in availableRestaurants">
          <restaurant
            :date="date"
            :key="restaurant.id"
            :restaurant="restaurant"
            :preorder="() => preorder(restaurant)"
          />
        </div>
        <div
          class="restaurant-item"
          v-for="restaurant in unavailableRestaurants"
        >
          <restaurant
            :key="restaurant.id"
            :restaurant="restaurant"
            :preorder="() => preorder(restaurant)"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import * as utils from "@/utils";
import Alarm from "@/components/Alarm";
import SkmHeader from "@/components/Header";
import { mapActions, mapState, mapGetters } from "vuex";
import Restaurant from "@/components/Preorder/Restaurant";
import PrimaryFilter from "@/components/Group/PrimaryFilter";
import PreorderFilter from "@/components/Preorder/PreorderFilter";
import PreorderTutorialButton from "@/components/Group/PreorderTutorialButton";

export default {
  components: {
    Alarm,
    SkmHeader,
    PrimaryFilter,
    PreorderFilter,
    Restaurant,
    PreorderTutorialButton
  },

  data() {
    const { time, date } = this.$route.query;
    return {
      time,
      date: date || moment().format("YYYY-MM-DD"),
      search: "",
      category: "all",
      buttons: [
        { name: "step1", icon: "login" },
        { name: "step2", icon: "selectPreordering" },
        { name: "step3", icon: "selectRestaurant" },
        { name: "step4", icon: "checkout" },
        { name: "step5", icon: "takeMeal" }
      ]
    };
  },

  methods: {
    ...mapActions("group", ["updateFilter", "loadGroup", "clear"]),

    fetchGroup() {
      this.updateFilter({ groupId: this.$route.params.groupId });
    },

    preorder(restaurant) {
      const { time, date } = this.$route.query;
      this.$router.push({
        name: "RestaurantPreorder",
        params: {
          companyId: restaurant.companyId,
          groupId: restaurant.groupId,
          id: restaurant.id
        },
        query: { time, date }
      });
    },

    updateStrategy({ category }) {
      this.category = category;
    },

    typeFilter(restaurants) {
      return restaurants.filter(restaurant => {
        return (
          this.category === "all" ||
          restaurant.restaurantTypes.find(typ => typ === this.category)
        );
      });
    },

    openPreorderTutorialPage(hash) {
      hash = hash.replace("#", "");
      this.$router.push(`/preorder-tutorial/${hash}`);
    }
  },

  computed: {
    ...mapGetters("theme", ["themeClasses"]),
    ...mapState("group", ["restaurants", "loading"]),
    ...mapState(["isMobile"]),

    strategies() {
      const restaurant = this.restaurants[0];
      return (restaurant && restaurant.preorderAvailableStrategies) || [];
    },

    enabledRestaurants() {
      return this.typeFilter(
        this.restaurants.filter(restaurant => restaurant.preorderEnabled)
      );
    },

    isToday() {
      const date = moment(this.date, "YYYY-MM-DD").add(3, "hours");
      return utils.isToday(date.toDate());
    },

    availableRestaurants() {
      return this.enabledRestaurants.filter(restaurant => {
        return restaurant.preorderTimes(this.isToday).length;
      });
    },

    unavailableRestaurants() {
      return this.enabledRestaurants.filter(restaurant => {
        return !restaurant.preorderTimes(this.isToday).length;
      });
    }
  },

  mounted() {
    window.gtag("event", `pageview`, {
      event_category: "美食地圖預定外帶",
      event_label: this.$route.params.groupId
    });
  }
};
</script>

<style lang="scss" scoped>
.primary-filter-container {
  max-width: 540px;
  margin: auto;
  @include media-breakpoint-up(md) {
    margin: 0;
  }
}

.fixed-top-filter {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  background-color: $color-white;
  z-index: 1000;
  box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.05),
    inset 0 -1px 0 0 $color-silver-grey;
  pointer-events: none;
  opacity: 0;
  transform: translateY(-100%);
  transition: opacity 0.2s, transform 0.5s;

  &--show {
    opacity: 1;
    transform: none;
    pointer-events: auto;
  }
}

.restaurant-list {
  background: $color-white;

  @include media-breakpoint-up(md) {
    background: inherit;
    display: flex;
    flex-flow: row wrap;
    position: relative;
    margin-left: -15px;
    margin-right: -15px;
  }
}

.restaurant-item {
  @include media-breakpoint-up(md) {
    flex: 0 1 33.333%;
    overflow: hidden;
  }
}

.restaurant-list-disabled {
  background-color: $color-genesis-white;
  color: $color-pigeon-grey;
  padding: 12.5px 20px 8px 20px;
  font-size: 14px;

  @include media-breakpoint-up(md) {
    flex: 1 0 100%;
    color: $color-primary-black;
    font-size: 28px;
    padding: 0;
    margin: 40px 15px 10px 15px;
  }
}

.alarm {
  .tutorial-button-container {
    display: inline-flex;
    flex-direction: row;
    align-items: center;
    margin-top: 10px;
    .ic-proc-next {
      display: block;
      width: 16px;
      height: 16px;
      background: url("/static/images/preorder-tutorial/ic-proc-next.svg");
      margin: 0 15px;
      &:last-child {
        display: none;
      }
    }
  }
}
.theme-vip-member {
  .restaurant-list {
    background: transparent;
  }
}
</style>
